unit mIRC;

interface

uses
  Windows;

type
  LongRec = packed record
    case Integer of
      0: (Lo, Hi: Word);
      1: (Words: array [0..1] of Word);
      2: (Bytes: array [0..3] of Byte);
  end;

function trim(const S: string): string;
function gettok(Source: string; const C: Char; N: Integer): string;
function NumTok(Text: string; C: Char): Integer;
function IsTok(Text: string; Token: string; C: Char): Boolean;
function InttoStr(i: integer): string;
function StrToInt(s: string): integer;
function str2(texto: string; vezes: integer): string; { igual ao $str do mIRC }
function FileExists(const FileName: string): Integer;
function ExtractIcon(Handle: HWND; FileName: PAnsiChar; nIcons: UINT): UINT; stdcall;

procedure StrCopy(data: PChar; const S: string);

implementation

procedure StrCopy(data: PChar; const S: string);
begin
  lstrcpy(data, PChar(S));
end;

function StrtoInt(s:string) : integer;
var i,e:integer;
begin
val(s,i,e);
result:=i;
end;

function InttoStr(i:integer) : string;
var s:string;
begin
str(i,s);
result:=s;
end;

function str2(texto: string; vezes: integer): string; { igual ao $str do mIRC }
var
  i : integer;
begin
  for i := 1 to vezes do
    result := result + texto;
end;

function Trim(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

function gettok(Source: string; const C: Char; N: Integer): string;
var
  SPos, Num: Integer;
  All: Boolean;
begin
  Result := '';
  All := (N < 0);
  if (N < 0) then
    N := N * -1;
  if (Source = '') then
    Exit;
  while (Source[1] = C) do
    Source := Copy(Source, 2, MaxInt);
  while (Source[Length(Source)] = C) do
    Source := Copy(Source, 1, Length(Source) - 1);
  Num := 1;
  SPos := Pos(C, Source);
  while (SPos > 0) do
  begin
    if (Num = N) then
    begin
      if (All) then
        Result := trim(Copy(Source, 1, MaxInt))
      else
        Result := trim(Copy(Source, 1, SPos - 1));
      Exit;
    end;
    Delete(Source, 1, SPos);
    Inc(Num);
    SPos := Pos(C, Source);
  end;
  if (Num = N) then
    Result := trim(Source);
end;

function NumTok(Text: string; C: Char): Integer;
var
 C_Position,Num: Integer;
begin
  Result := 0;
  Text := trim(Text);
  if (Text = '') then
    Exit;
  while (Text[1] = C) do
    Text := Copy(Text,2,MaxInt);
  while (Text[Length(Text)] = C) do
    Text := Copy(Text,1,Length(Text)-1);
  Num := 1;
  C_Position := Pos(C,Text);
  while (C_Position > 0) do
  begin
    Delete(Text,1,C_Position);
    Inc(Num);
    C_Position := Pos(C,Text);
  end;
  Result := Num;
end;

function IsTok(Text: string; Token: string; C: Char): Boolean;
var
  C_Position: Integer;
begin
  Result := false;
  Text := trim(Text);
  Token := trim(Token);
  if ((Text = '') or (Token = '')) then
    Exit;
  while (Text[1] = C) do
    Text := Copy(Text,2,MaxInt);
  while (Text[Length(Text)] = C) do
    Text := Copy(Text,1,Length(Text)-1);
  while (Token[1] = C) do
    Token := Copy(Token,2,MaxInt);
  while (Token[Length(Token)] = C) do
    Token := Copy(Token,1,Length(Token)-1);
  C_Position := Pos(C,Text);
  while (C_Position > 0) do
  begin
    if (Token = Copy(Text,1,C_Position -1)) then
    begin
      Result := true;
      exit;
    end;
    Delete(Text,1,C_Position);
    C_Position := Pos(C,Text);
  end;
  if (Token = Copy(Text,1,MaxInt)) then
    Result := true;
end;

function FileExists(const FileName: string): Integer;
var
  Handle: THandle;
  FindData: TWin32FindData;
  LocalFileTime: TFileTime;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then
  begin
    Windows.FindClose(Handle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
      if FileTimeToDosDateTime(LocalFileTime, LongRec(Result).Hi,
        LongRec(Result).Lo) then Exit;
    end;
  end;
  Result := 0;
end;

function ExtractIcon(Handle: HWND;
                       FileName: PAnsiChar;
                       nIcons: UINT): UINT; stdcall;
  external 'shell32.dll' name 'ExtractIconA';
end.